package bg.bas.dcl.entities;

import java.io.IOException;
import java.util.ArrayList;

public class DerivationModel {

	public String pos1 = "";
	public String pos2 = "";
	
	public String prefix1 = "";
	public String suffix1 = "";
	
	public String prefix2 = "";
	public String suffix2 = "";

	public ArrayList<String> suffixvar1 = new ArrayList<String>();
	public ArrayList<String> suffixvar2 = new ArrayList<String>();

	public ArrayList<String> relations = new ArrayList<String>();
	
	public boolean correspondsToModel(String w1, String p1, 
			String w2, String p2){
				
		String n1 = "";
		String v2 = "";
		ArrayList<String> variants1 = new ArrayList<String>();
		ArrayList<String> variants2 = new ArrayList<String>();

		if (pos1.equals(p1) && pos2.equals(p2)){
			n1 = w1;
			v2 = w2;
			variants1.addAll(suffixvar1);
			variants2.addAll(suffixvar2);
		} 
		if (pos2.equals(p1) && pos1.equals(p2)){
			n1 = w2;
			v2 = w1;
			variants1.addAll(suffixvar2);
			variants2.addAll(suffixvar1);
		} 
		
		if (v2.endsWith(" се")||v2.endsWith(" си")){
			v2 = v2.substring(0, v2.length()-3);
		}
		
		for (String suffix2 : variants1){
			for (String suffix1 : variants2){
				
				System.out.println("\t\t--"+suffix1 + "-- --" + suffix2+"--");
			
				if ((prefix1.length()==0 || n1.startsWith(prefix1))
						&& (prefix2.length()==0 || v2.startsWith(prefix2))
						&& (suffix1.length()==0 || n1.endsWith(suffix1))
						&& (suffix2.length()==0 || v2.endsWith(suffix2))
						){
					
					String base1 = n1;
					String base2 = v2;
					
					if (prefix1.length()>0) base1 = base1.substring(prefix1.length());
					if (prefix2.length()>0) base2 = base2.substring(prefix2.length());
					
					if (suffix1.length()>0) base1 = base1.substring(0,base1.length()-suffix1.length());
					if (suffix2.length()>0) base2 = base2.substring(0,base2.length()-suffix2.length());
		
					System.out.println("BASES: n:"+base1+" v:"+base2);
		
					if (base1.equals(base2)) return true;
					
				}
			}
		}
		
		return false;

		
		
	}
	
	public boolean correspondsToModelStrict(String w1, String p1, 
			String w2, String p2){
		
		String n1 = "";
		String v2 = "";

		if (pos1.equals(p1) && pos2.equals(p2)){
			n1 = w1;
			v2 = w2;
		} 
		if (pos2.equals(p1) && pos1.equals(p2)){
			n1 = w2;
			v2 = w1;
		} 
		
//		for (String suffix1 : variants1){
//			for (String suffix2 : variants2){
			
				if ((prefix1.length()==0 || n1.startsWith(prefix1))
						&& (prefix2.length()==0 || v2.startsWith(prefix2))
						&& (suffix1.length()==0 || n1.endsWith(suffix1))
						&& (suffix2.length()==0 || v2.endsWith(suffix2))
						){
					
					String base1 = n1;
					String base2 = v2;
					
					if (prefix1.length()>0) base1 = base1.substring(prefix1.length());
					if (prefix2.length()>0) base2 = base2.substring(prefix2.length());
					
					if (suffix1.length()>0) base1 = base1.substring(0,base1.length()-suffix1.length());
					if (suffix2.length()>0) base2 = base2.substring(0,base2.length()-suffix2.length());
		
					System.out.println("BASES: n:"+base1+" v:"+base2);
		
					if (base1.equals(base2)) return true;
					
				}
//			}
//		}
		
		return false;

		
		
	}


	
	public String getDerivationModel(){
		String result = "";
		
		result += pos1 + ":" 
				+ (prefix1.length()>0?prefix1+"- ":"") 
				+ (suffix1.length()>0?"-"+suffix1:"")
				+ " "
				+ pos2 + ":" 
				+ (prefix2.length()>0?prefix2+"- ":"") 
				+ (suffix2.length()>0?"-"+suffix2:"");
		
		return result;
	}
	
	public String getPossibleRelations(){
		String result = "";
		
		for (String r : relations) result += r+"; ";
		
		return result;
	}
	
	public boolean isTheSameModel(DerivationModel mod){
				
		if(!pos1.equals(mod.pos1)) return false;
		if(!pos2.equals(mod.pos2)) return false;
		if(!prefix1.equals(mod.prefix1)) return false;
		if(!prefix2.equals(mod.prefix2)) return false;
		if(!suffix1.equals(mod.suffix1)) return false;
		if(!suffix2.equals(mod.suffix2)) return false;

		return true;
	}

	
}
