package bg.bas.dcl.general;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.Writer;
import java.util.ArrayList;
import java.util.HashMap;

import org.json.simple.JSONObject;
import org.json.simple.parser.JSONParser;

public class JSONProcessor {

    public ArrayList<String> orderedAttr = new ArrayList<String>();
    public ArrayList<String> orderedAttrEn = new ArrayList<String>();
    
    public HashMap<String,String> attrTranslations = new HashMap<String,String>();

    public JSONProcessor(){
    	setupLabels();
    }
    
    public void setupLabels(){
    	
    	orderedAttr.add("име на файла");
    	orderedAttr.add("автор");
    	orderedAttr.add("заглавие");
    	orderedAttr.add("превод");
    	orderedAttr.add("преводач");
    	orderedAttr.add("дата на публикуване");
    	orderedAttr.add("година на създаване");
    	orderedAttr.add("стил");
    	orderedAttr.add("тематична област");
    	orderedAttr.add("тематична област 2");
    	orderedAttr.add("информация за тематичната област");
    	orderedAttr.add("жанр");
    	orderedAttr.add("информация за жанра");
    	orderedAttr.add("тип източник");
    	orderedAttr.add("източник");
    	orderedAttr.add("ключови думи");
    	orderedAttr.add("бележки");
    	orderedAttr.add("медиум");
    	orderedAttr.add("брой думи");
    	orderedAttr.add("качество");
    	orderedAttr.add("достъп");

    	
    	orderedAttrEn.add("filename");
    	orderedAttrEn.add("author");
    	orderedAttrEn.add("title");
    	orderedAttrEn.add("translated");    	
    	orderedAttrEn.add("translator");
    	orderedAttrEn.add("publishing date");
    	orderedAttrEn.add("year of creation");
    	orderedAttrEn.add("style");
    	orderedAttrEn.add("domain1");
    	orderedAttrEn.add("domain2");
    	orderedAttrEn.add("domain info");
    	orderedAttrEn.add("genre");
    	orderedAttrEn.add("genre info");
    	orderedAttrEn.add("source type");
    	orderedAttrEn.add("source");
    	orderedAttrEn.add("keywords");
    	orderedAttrEn.add("notes");
    	orderedAttrEn.add("medium");
    	orderedAttrEn.add("number of words");
    	orderedAttrEn.add("quality");
    	orderedAttrEn.add("accessibility");
    	
     }

	public JSONObject readJSON (File f){
		
		JSONParser parser = new JSONParser();

		try {

			JSONObject jobj = (JSONObject)parser.parse(new InputStreamReader(
					new FileInputStream(f), "UTF-8"));
			
			return jobj;
			
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		return null;
	}

	   
    public void writeJSONToFile(JSONObject obj, String file){
    	
    	try{
    		Writer out =  new OutputStreamWriter(
    				new FileOutputStream(file),"UTF-8");
    		
    		out.write(obj.toJSONString());
    		out.flush();
    		out.close();
    		
    	} catch(Exception e){
    		e.printStackTrace();
    	}
    		
    }
    
    public JSONObject createNewJSON(String fname){
    	JSONObject bg = new JSONObject();
    	JSONObject en = new JSONObject();
    	
    	for (String attr : orderedAttr) bg.put(attr, "");
    	for (String attr : orderedAttrEn) en.put(attr, "");
    	
    	bg.put("име на файла", fname);
    	en.put("filename", fname);
    	
    	JSONObject jobj = new JSONObject();
    	jobj.put("bg", bg);
    	jobj.put("en", en);
    	
    	return jobj;

    }
    
    



}
