package bg.bas.dcl.monolingual.bg;

import java.io.IOException;
import java.io.Writer;
import java.util.ArrayList;
import java.util.HashMap;

import bg.bas.dcl.entities.AgreementObject;
import bg.bas.dcl.entities.Clause;
import bg.bas.dcl.entities.NounPhraseWords;
import bg.bas.dcl.entities.Verb;
import bg.bas.dcl.entities.Word;

public class AnaphoraResolver {
	
	SentenceAnalyser senAn = new SentenceAnalyser();
	
	public HashMap<String,Clause> anaphoraResolution(HashMap<String,Clause> clauses, 
			ArrayList<String> clauseOrder, Writer out) throws IOException{
		
		
f0:		for (int i = 0; i < clauseOrder.size(); i++){
			
System.err.println("CL:"+ clauseOrder.get(i));
			Clause cl = clauses.get(clauseOrder.get(i));

			int verbIndex = senAn.getVerbIndex(cl);
			
			AgreementObject anaphoraAgreement = new AgreementObject();
			
f1:			for (int j = 0; j < cl.size(); j++){	
				
				if (cl.get(j).pos.startsWith("PRO")
						|| cl.get(j).pos.startsWith("PP")
						|| cl.get(j).pos.startsWith("PH")
						) {
					
					System.err.println("PROCESSED "+cl.get(j).wordform 
							+ ","+cl.get(j).pos+","+cl.get(j).wordID);
					
					AgreementObject proAgreement = new AgreementObject();
					proAgreement.setGenderFromWord(cl.get(j));
					proAgreement.setNumberFromWord(cl.get(j));
					proAgreement.setPersonFromWord(cl.get(j));
				
					if (cl.get(j).pos.startsWith("PP")) 
						proAgreement.setGender(
							(cl.get(j).pos.endsWith("ge")? "mn" :
								cl.get(j).pos.endsWith("gb")? "f" : "")
							);
					if (cl.get(j).pos.startsWith("PP")) 
						proAgreement.setNumber(
							(cl.get(j).pos.endsWith("u")? "p" : "s")
							);					

					System.err.println("PROCESSED "+proAgreement.gender 
							+ ","+proAgreement.number);
										
					ArrayList<NounPhraseWords> list = senAn.getNounPhrases (cl);
					System.err.println("LIST SIZE "+list.size());
					
					for (NounPhraseWords f : list) System.err.println(f.head.wordform+","+f.head.wordID);
					
					for (int k = list.size()-1; k >= 0; k--){
						
						if (list.get(k).start > j) continue;
						
						AgreementObject npAgreement = new AgreementObject();
						
						if (cl.get(j).pos.startsWith("PRO")){
						}
						
//						if (cl.get(j).pos.startsWith("PP")){
							npAgreement.setGenderFromWord(list.get(k).head);
							npAgreement.setNumberFromWord(list.get(k).head);
							npAgreement.setPersonFromWord(list.get(k).head);
//						}
//						if (cl.get(j).pos.startsWith("PH")){
//							npAgreement.setGenderFromWord(list.get(k).head);
//							npAgreement.setNumberFromWord(list.get(k).head);
//							npAgreement.setPersonFromWord(list.get(k).head);
//						}

						if (cl.get(j).wordID - list.get(k).head.wordID==1) continue;
						if (j>2 && cl.get(j-1).pos.equals("R") 
								&& cl.get(j).wordID - list.get(k).head.wordID==2) continue;
						
						System.err.println("HEAD "+list.get(k).head.wordform 
								+ ","+list.get(k).head.pos+","+list.get(k).head.wordID);
						System.err.println("HEAD "+npAgreement.gender 
								+ ","+npAgreement.number+","+list.get(k).head.wordID);

						if (npAgreement.agreesWith(proAgreement)
								&& cl.get(j).wordID > list.get(k).head.wordID) {
							
							cl.get(j).reference = list.get(k).head;;

									System.err.println("MATCH " +cl.get(j).wordform+" "+
											list.get(k).head.wordform );
									continue f1;
						}

					}
					
					
					
					for (int l = 1; l < 5; l++){
						
						if (i<l) continue f1;
						
						Clause clprev = clauses.get(clauseOrder.get(i-l));
						System.out.println(clprev.toString());
						
						ArrayList<NounPhraseWords> listprev = senAn.getNounPhrases (clprev);
						System.out.println(listprev.size());
						
						for (int k = listprev.size()-1; k >= 0; k--){
							
							AgreementObject npAgreement = new AgreementObject();
//							if (cl.get(j).pos.startsWith("PRO")){
								npAgreement.setGenderFromWord(listprev.get(k).head);
								npAgreement.setNumberFromWord(listprev.get(k).head);
								npAgreement.setPersonFromWord(listprev.get(k).head);
//							}
							
//							if (cl.get(j).pos.startsWith("PP")){
//							}

//							if (cl.get(j).pos.startsWith("PH")){
//								npAgreement.setGenderFromWord(listprev.get(k).head);
//								npAgreement.setNumberFromWord(listprev.get(k).head);
//								npAgreement.setPersonFromWord(listprev.get(k).head);
//							}
								System.out.println(npAgreement.gender + "\t" + npAgreement.number 
										+ "\t" + npAgreement.person);
							if (npAgreement.agreesWith(proAgreement)
									&& cl.get(j).wordID > listprev.get(k).head.wordID) {
								cl.get(j).reference = listprev.get(k).head;

								System.err.println("MATCH " +cl.get(j).wordform+" "+
										listprev.get(k).head.lemma );
								continue f1;
							}
	
						}
					}
					
				}
				

			}
			
		}
		

		for (int i = 0; i < clauseOrder.size(); i++){
			
			Clause cl = clauses.get(clauseOrder.get(i));
			
			for (Word w : cl) {
				
				if (w.pos.startsWith("PH")
						|| w.pos.startsWith("PP")
						|| w.pos.startsWith("PRO")){
					out.write("<font color=\"red\"><b>"+w.wordform+"</b></font>");
					
				} else {
					out.write(w.wordform);
				}
				
				if (w.reference != null) {
					out.write("(" + w.reference.wordform + ")");
				}
//				out.write(","+w.pos+","+w.wordID);
				out.write(" ");
			}
			
			out.write("\n<br><br>\n");
			
		}		
		
		return clauses;
	}
	


}
