package bg.bas.dcl.monolingual.bg;

import java.io.File;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Scanner;

public class KeywordExtractor {
	
	public String getKeywords(File f, int maxctr, int minfreq) {
		
		String result = "";
		
		try{
			
			TextProcessor tp = new TextProcessor();
			
			Scanner s = new Scanner(f);
			
			HashMap<String,Integer> freq = new HashMap<String,Integer>();
			int maxfreq = 0;

			String text = "";

			while (s.hasNextLine()){
					String l = s.nextLine().trim();
				
					if (l.equals("")) continue;
				
					text += " " + l;


			}

			s.close();

			String tagged = tp.applyServiceToText(text, 2);
//			System.out.println("Tagged: "+tagged);
			
			String[] words = tagged.split("\n");
			
			
			for (String w : words){
			
				String[] data = w.split("\t");
				if (data.length<4) continue;
		
				String lemma = data[data.length-2];
				String pos = data[data.length-1];
				
				if (pos.startsWith("N")){
					if (freq.containsKey(lemma)){
						freq.put(lemma, freq.get(lemma)+1);
					} else {
						freq.put(lemma, 1);
					}

					if (freq.get(lemma) > maxfreq) maxfreq = freq.get(lemma);

				}
				
			}
			
			
			Map<String, Integer> sorted = sortByComparator(freq, false);

			int ctr = 0;
			
			 for (Entry<String, Integer> entry : sorted.entrySet()){
				 
				 System.out.println(entry.getKey() + "\t" + entry.getValue());
		         				 
				 if (entry.getValue() < minfreq) break;
				 result += entry.getKey() + "; ";
				 ctr ++;
		    
				 if (ctr > maxctr) break;
			 }
			
			
			
		} catch(Exception e){
			e.printStackTrace();
		}
		
		
		return result;
		
	}
	
	   private static Map<String, Integer> sortByComparator(Map<String, Integer> unsortMap, final boolean order)
	    {

	        List<Entry<String, Integer>> list = new LinkedList<Entry<String, Integer>>(unsortMap.entrySet());

	        // Sorting the list based on values
	        Collections.sort(list, new Comparator<Entry<String, Integer>>()
	        {
	            public int compare(Entry<String, Integer> o1,
	                    Entry<String, Integer> o2)
	            {
	                if (order)
	                {
	                    return o1.getValue().compareTo(o2.getValue());
	                }
	                else
	                {
	                    return o2.getValue().compareTo(o1.getValue());

	                }
	            }
	        });

	        // Maintaining insertion order with the help of LinkedList
	        Map<String, Integer> sortedMap = new LinkedHashMap<String, Integer>();
	        for (Entry<String, Integer> entry : list)
	        {
	            sortedMap.put(entry.getKey(), entry.getValue());
	        }

	        return sortedMap;
	    }

	

}
