package bg.bas.dcl.multilingual.Chunker.VerbFormRecogniser;

import java.util.ArrayList;
import java.util.HashMap;

import bg.bas.dcl.entities.Sentence;
import bg.bas.dcl.entities.TextPosition;
import bg.bas.dcl.entities.VerbForm;
import bg.bas.dcl.multilingual.ClauseSplitting.ClauseSplittingFileProcessor;

public class ClauseVerbsVerifier {
	
	public int compositeDistanceMAX = 4;
	
	HashMap<String,ArrayList<String>> specialVerbs = new HashMap<String,ArrayList<String>>();
	
	public ClauseVerbsVerifier(String filename){
		
		ClauseSplittingFileProcessor csfp = new ClauseSplittingFileProcessor();
		specialVerbs = csfp.readSpecialVerbsFromFile(filename);	
	}
		
	public ArrayList<ClauseVerb> reviseVerbs(Sentence sentence, ArrayList<VerbForm> verbs){
		
		ArrayList<ClauseVerb> clVerbs = new ArrayList<ClauseVerb>();
		
main: for (int i = 0; i < verbs.size(); i++){
			
			ClauseVerb clv = new ClauseVerb();
			VerbForm vf = verbs.get(i);
			
			clv.addAll(vf);
			clv.list.add(vf.get(0).sentpos);
			clv.tenses.add(vf.tense);
			clv.mainword = vf.mainword;
			
			System.out.println(i + "\t"+vf.tense.get(0));
			
			if (vf.tense.get(0).startsWith("NVerb")) continue main;
			if (vf.tense.contains("NVerb")) continue main;

			

			if (sentence.get(vf.get(0).sentpos).wordform.equalsIgnoreCase("може")
					&& vf.get(0).sentpos<sentence.size()-1
					&& sentence.get(vf.get(0).sentpos+1).wordform.equalsIgnoreCase("би")) continue main;
			if (sentence.get(vf.get(0).sentpos).wordform.equalsIgnoreCase("би")
					&& vf.get(0).sentpos>0
					&& sentence.get(vf.get(0).sentpos-1).wordform.equalsIgnoreCase("може")) continue main;

			
			if ((vf.tense.contains("DVerb+Past_Participle_Aorist")
					|| vf.tense.contains("DVerb+Past_Participle_Imperfect"))
					&& vf.get(0).sentpos>0 
					&& sentence.get(vf.get(0).sentpos-1).wordform.equals(",")) {
				
				continue main;
			}

			boolean m = hasType(sentence, vf,"modal");
			boolean p = hasType(sentence, vf,"phase");
			
			int j=i;
			
			while (m || p){
				
				j++;
				int ci = -1;
				
				if (j<verbs.size()) {
					
					boolean hasConnector = false;
					
					if (!specialVerbs.containsKey("conjunction")) hasConnector = true;
					else {
						for (String c : specialVerbs.get("conjunction")){
							for (int k = verbs.get(j-1).get(verbs.get(j-1).size()-1).sentpos; 
									k<verbs.get(j).get(0).sentpos; k++){
								
								if (sentence.get(k).pos.equals("U")) break;
									
								if (sentence.get(k).lemma.equals(c)) {
									hasConnector = true;
									ci = k;
									break;
								}
							}
							if (hasConnector) break;
						}
					}
					
					if (hasConnector) {
						
//						clv.add(ci);
						
						clv.list.add(ci);
						clv.tenses.add(null);
						
						clv.addAll(verbs.get(j));
						clv.list.add(verbs.get(j).get(0).sentpos);
						clv.tenses.add(verbs.get(j).tense);
						
						i=j;

						
					} else {
						break;
					}
					
					
					m = hasType(sentence, verbs.get(j),"modal"); 
					p = hasType(sentence, verbs.get(j),"phase");

				} else break;
				
			}
			
			clVerbs.add(clv);
		}
		
		return clVerbs;
	}

	
	public boolean hasType(Sentence sentence, VerbForm vf, String type){
		
		ArrayList<String> list = specialVerbs.get(type);
		
		for (String w : list){
			
			for (TextPosition ti : vf) {
				if (sentence.get(ti.sentpos).lemma.equals(w)){
					return true;
				}
			}
		}
		
		return false;
	}
	
	
	public boolean fullVerb(VerbForm vf){
		boolean fullVerb = true;
		for (String t : vf.tense) {
			if (t.startsWith("NVerb") || t.startsWith("DVerb")) {
				return false;
				
			}
		}			
		return fullVerb;
	}

	public boolean isModal(VerbForm vf){
		boolean is = false;
		
		for (String t : vf.tense) {
			if (t.startsWith("NVerb")) {
				is = false;
				
				break;
			}
		}			
		return is;
	}

}
