package bg.bas.dcl.multilingual.Chunker.VerbFormRecogniser;

import java.util.ArrayList;

import bg.bas.dcl.entities.Word;

public class VerbComponent {
	
	public String form = "";
	public String lemma = "";
	public String pos = "";
	public String gram = "";
	
	public boolean optional = false;
	public int optionalNum = 0;
	public ArrayList<VerbComponent> optionalVariants = 
			new ArrayList<VerbComponent>();
	
	String enAux = " be have ";
	String bulAux = " съм ща нямам няма бъда ";

	public boolean isAux(){
		if (enAux.contains(" "+lemma+" ")) return true;
		if (bulAux.contains(" "+lemma+" ")) return true;
		if (optional) return true;
		
		return false;
	}
	
	public void readComponentFromString(String comp){
		
		comp = comp.trim();
		
		if (comp.contains(":")) {
			lemma = comp.substring(0,comp.indexOf(":"));
			comp = comp.substring(comp.indexOf(":")+1);
		} else {
			if (comp.length()>0 && comp.charAt(0) != '-' 
					&& (comp.charAt(0)<'A' || comp.charAt(0)>'Z')) {
				lemma = comp;
				comp = "";
			}
		}	
		
		while (comp.length()>0 
				&& (comp.charAt(0) == '-' 
				|| (comp.charAt(0)>='A' && comp.charAt(0)<='Z'))){
			pos += comp.charAt(0);
			comp = comp.substring(1);
		}
		
		gram = comp;
		
	}

	public void readComponentTypeFromString(String comp, int n){
		

		if (comp.startsWith("(") && comp.endsWith(")")) {
		
			comp = comp.substring(1, comp.length()-1);

			String options1 = comp.substring(0,comp.indexOf(","));
					
			String options2 = comp.substring(comp.indexOf(",")+1);

			optional = true;
			
			if (options1.equals("n")) optionalNum = n;
			else optionalNum = Integer.valueOf(options1);
			
//			System.out.println("OPTIONS "+optionalNum+" "+options2);
			
			if (options2.startsWith("{") && options2.endsWith("}")){
				String[] variants = options2.substring(1,options2.length()-1)
						.split(",");
				
				for (String v : variants){
					VerbComponent vc = new VerbComponent();
					vc.readComponentFromString(v.trim());
					
//					System.out.println("OPTIONAL "+
//							v + "\t" + vc.lemma + "\t" + vc.pos);
					optionalVariants.add(vc);
					
					
							
				}
				
			}
			
		} else readComponentFromString(comp);

		
	}
	
	public boolean isMatchPosAndGram(Word t){
		
		for (int i = 0; i<pos.length(); i++) {
			
			String s = pos.substring(i, i+1);

			if (!t.pos.startsWith(s)) {
				
				return false;
			}

		}
		
		for (int i = 0; i<gram.length(); i++) {
			
			String s = gram.substring(i, i+1);
			
			if (pos.equals("V") && gram.equals("d")
					&& (t.pos.contains("q")
							|| t.pos.contains("y")
							|| t.pos.contains("x"))) {
				return false;
			
			}
			
			if (!t.pos.contains(s)) return false;
			
		}
		
		return true;

	}

	public boolean isMatch(Word t){
		
		
		boolean res = true;
		
		if (!lemma.equals("") && !lemma.equals(t.lemma)) return false;

		if (!optional) {

			res = isMatchPosAndGram(t);
//			System.out.println("CMATCH " + t.lemma + "\t" + pos + "\t"
//					+ t.pos + "\t" + lemma + "\t"+ res);
			
			
		} else {

			boolean variant;
			
			if (optionalVariants.get(0).pos.startsWith("-")){
				variant = true;
				for (VerbComponent vc : optionalVariants) {
//					System.out.println("-MATCH " + t.pos + "\t" + vc.pos.substring(1));
					
					if (t.pos.startsWith(vc.pos.substring(1))) {
						variant = false;
					}
				}
			} else {
				variant = false;
				for (VerbComponent vc : optionalVariants) {
					
					variant = variant || vc.isMatch(t);

//					System.out.println("+MATCH " + t.pos + "\t" + vc.pos
//							+ "\t" + variant);
				}
			}
			
//			System.out.println("MATCH " + t.pos + "\t" + optionalVariants.get(0).pos + "\t"+variant);
			return variant;
			
		}
	
		/**
		System.out.println(lemma
				+"\t" + pos
				+"\t" + optional
				+"\t" + t.lemma
				+"\t" + t.pos);
		*/

		return res;
		
	}

}
