package bg.bas.dcl.multilingual.ClauseSplitting;

import java.io.File;
import java.io.FileOutputStream;
import java.io.OutputStreamWriter;
import java.io.Writer;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import bg.bas.dcl.entities.Sentence;
import bg.bas.dcl.entities.TextPosition;
import bg.bas.dcl.entities.VerbForm;
import bg.bas.dcl.entities.Word;
import bg.bas.dcl.general.FileHandler;
import bg.bas.dcl.general.InitialParametersReader;
import bg.bas.dcl.multilingual.Chunker.VerbFormRecogniser.ClauseVerb;
import bg.bas.dcl.multilingual.Chunker.VerbFormRecogniser.ClauseVerbsVerifier;
import bg.bas.dcl.multilingual.Chunker.VerbFormRecogniser.VerbFormFormalism;

public class BulEnACProcessor {
	
	ClauseVerbsVerifier cvv;	
	VerbFormFormalism vff;

	ClauseVerbsVerifier cvven;	
	VerbFormFormalism vffen;
	
	HashMap<String,ArrayList<String>> frames;
	HashMap<String,ArrayList<String>> framesen;

	public static void main(String[] args) {
		// TODO Auto-generated method stub
		
		BulEnACProcessor pr = new BulEnACProcessor();
		
		String corpusDirSen = "/home/ivelina/WORK-DCL/BulEnAC/" +
				"CORPUS/BulEnAC-pos-bg-en_PROCESSED/";		
		String corpusDir = "/home/ivelina/WORK-DCL/BulEnAC/" +
				"CORPUS/BulEnAC/";		
		String outDir = "/home/ivelina/WORK-DCL/BulEnAC/" +
				"CORPUS/BulEnAC-20161117/";		

		String corpusDirVF = "/home/ivelina/WORK-DCL/BulEnAC/" +
				"CORPUS/BulEnAC-20161117/";		

		String outDirVF = "/home/ivelina/WORK-DCL/BulEnAC/" +
				"CORPUS/BulEnAC-20161117-VerbForms/";		

		String modelsFile = "/home/ivelina/WORK-DCL/BulEnAC/" +
				"resources/verb-form-models.txt";		
		String modelsFileEn = "/home/ivelina/WORK-DCL/BulEnAC/" +
				"resources/verb-form-models-en.txt";
		
		String verbsFile = "/home/ivelina/WORK-DCL/BulEnAC/" +
				"resources/special-verbs.txt";  
		String verbsFileEn = "/home/ivelina/WORK-DCL/BulEnAC/" +
				"resources/special-verbsEn.txt";  

		String fframes = "/home/ivelina/WORK-DCL/BulEnAC/" +
				"resources/framenet-frames-bg.txt";  
		String fframesEn = "/home/ivelina/WORK-DCL/BulEnAC/" +
				"resources/framenet-frames-en.txt";  
		
		HashMap<String,ArrayList<String>> frames = 
				InitialParametersReader.readDictionaryMultipleValues(fframes);
		HashMap<String,ArrayList<String>> framesen = 
				InitialParametersReader.readDictionaryMultipleValues(fframesEn);
		


		pr.vff = new VerbFormFormalism();		
		pr.vff.readModelsFromFile(modelsFile);
		pr.cvv = new ClauseVerbsVerifier(verbsFile);

		pr.vffen = new VerbFormFormalism();		
		pr.vffen.readModelsFromFile(modelsFileEn);
		pr.cvven = new ClauseVerbsVerifier(verbsFileEn);

//		pr.processCorpusXML(corpusDir,corpusDirSen, outDir, "txt");
//		pr.processCorpusXML(corpusDir,corpusDirSen, outDir, "al");
	
		pr.processCorpusXMLVerbForms(corpusDirVF, outDirVF, "txt", frames);
		pr.processCorpusXMLVerbForms(corpusDirVF, outDirVF, "al", framesen);

	}
	
	public void processCorpusXML(String corpusDir, String corpusDir1, 
			String outDir, String ext){
		
		FileHandler fh = new FileHandler();

		try{
			List<File> list = fh.getFileListing(
					new File(corpusDir));
			
			for (File f : list) {
				
				if (!f.isFile()) continue;
				if (f.getName().startsWith(".")) continue;
				if (f.getName().contains("~")) continue;
				if (!f.getName().endsWith(ext)) continue;
				
				String ff = f.getAbsolutePath()
						.replace(corpusDir, outDir);
				FileHandler.makeParent(ff, "");
				Writer out = new OutputStreamWriter(
						new FileOutputStream(
								ff));

				String f1n = f.getAbsolutePath()
						.replace(corpusDir, corpusDir1);
				processFileXML(f, new File(f1n), out, ext);

				out.flush();
				out.close();
		
//				break;
//				System.exit(0);
			}


		} catch(Exception e){
			e.printStackTrace();
		}
		
	}
	
	public void processCorpusXMLVerbForms(String corpusDir, 
			String outDir, String ext, 
			HashMap<String,ArrayList<String>> frames){
		
		FileHandler fh = new FileHandler();

		try{
			
			
			List<File> list = fh.getFileListing(
					new File(corpusDir));
			
			for (File f : list) {
				
				if (!f.isFile()) continue;
				if (f.getName().startsWith(".")) continue;
				if (f.getName().contains("~")) continue;
				if (!f.getName().endsWith(ext)) continue;
				
				String ff = f.getAbsolutePath()
						.replace(corpusDir, outDir);
				FileHandler.makeParent(ff, "");
				Writer out = new OutputStreamWriter(
						new FileOutputStream(
								ff));

				processFileXMLVerbForms(f, out, ext, frames);

				out.flush();
				out.close();
		
//				break;
//				System.exit(0);
			}


		} catch(Exception e){
			e.printStackTrace();
		}
		
	}

	

	public void processFileXML(File f, File f1, Writer out, 
			String ext){
		
		try{
			

			ArrayList<Sentence> sents = getSentences(f);
			ArrayList<Sentence> sents_sen = getSentencesWithS(f1);
			

			System.out.println(f.getAbsolutePath());			
			System.out.println(f1.getAbsolutePath());
			
//			System.in.read();

			if (sents.size()>0 && sents_sen.size()>0
					//&& sents.size()!=sents_sen.size()
					)

ll:			for (int i = 0; i<Math.min(sents.size(),sents_sen.size()); i++){
								
	System.out.println(sents.size() + "\t" + sents_sen.size()
			+ "\t" + (sents.size()==sents_sen.size()));

	
	



				if (i<Math.min(sents.size(),sents_sen.size())-1) {
					if (!sents.get(i+1).get(0).clauseID
							.equals(sents_sen.get(i+1).get(0).clauseID)){
						
						if (sents_sen.get(i).size() != sents.get(i).size()){
							if (0.9*sents_sen.get(i).size() < sents.get(i).size()){
								sents_sen.get(i).addAll(sents_sen.get(i+1));
								sents_sen.get(i).ID = sents_sen.get(i+1).ID;
								
								sents_sen.remove(i+1);
							} else {
								sents.get(i).addAll(sents.get(i+1));
								sents.get(i).ID = sents.get(i+1).ID;
								
								sents.remove(i+1);
							}	
						
						i--;
//						System.in.read();

						continue ll;
						}
						
					}
				}
				
				System.out.println(sents.get(i).getPlainText());
				System.out.println(sents_sen.get(i).getPlainText());

//				sents.get(i).ID = sents_sen.get(i).ID;
				
//				System.out.println("SEN: " + sents.get(i).ID);

				sents_sen.get(i).ID = sents.get(i).ID;
				sents_sen.get(i)
					.get(sents_sen.get(i).size()-1).sen = sents.get(i).ID;
				sents_sen.get(i)
					.get(sents_sen.get(i).size()-1).senEnd = true;
			
//				System.out.println("SEN: " + sents_sen.get(i).ID);
//				System.out.println("CHECK: " 
//						+ sents_sen.get(i).get(0).toXML());
//				System.in.read();
				
				for (int j = 0; j<sents.get(i).size(); j++){
					
					
					Word w = sents.get(i).get(j);

					if (!w.clauseAlign.equals("")){
						
						for (int k = 0; k<sents_sen.get(i).size(); k++){
							
							if (sents_sen.get(i).get(k).clauseID
									.equals(w.clauseID)){
								sents_sen.get(i).get(k).clauseAlign
									= w.clauseAlign;
								break;
							}
						}
						
					}
					if (!w.clauseRelation.equals("")
							|| !w.cclauseRelation.equals("")){
									
//						System.out.println("RELS: " + w.toXML());
//						System.in.read();

						for (int k = 0; k<sents_sen.get(i).size(); k++){
							
							if (sents_sen.get(i).get(k).clauseID
									.equals(w.clauseID)
									&& sents_sen.get(i).get(k).lemma
									.equals(w.lemma)){
								
								sents_sen.get(i).get(k).clauseConnectedID
								= sents.get(i).get(j).clauseConnectedID;

								int ti = 0;
								
								while (!sents.get(i).get(j+ti).CMWE_part										
										.equals("")){
									
									sents_sen.get(i).get(k+ti).CMWE_part
									= sents.get(i).get(j+ti).CMWE_part;
									ti++;
								}
								
								break;
							}
						}
						
					}
					
				}
				

				
				/**
				ClauseSplittingComplexObject obj = processSentence(sent, verbs);
				
//				System.out.println("BOUNDARIES "+obj.clborders.size());

				sent = assignClauses(sent, obj.clborders);
				
				obj.clborders = reviseBoundaries(sent, obj.clborders);

//				System.out.println("BOUNDARIES "+obj.clborders.size());

				sent = assignClauses(sent, obj.clborders);

				
				ArrayList<Integer> res = evaluate(sent, obj, verbs, errorout);
				updateEvaluationResults(res);
				
				out.write(verbs.size()+"\t"+obj.clborders.size()+"<br>");
				printColourHTML(out, sent, obj, verbs);
				
//				System.in.read();
				
//				System.out.println(getSentencePlainText(sent));
//				System.out.println("SPLITTING:");
				
				for (ClauseBorder cb : obj.clborders) {
					
//					System.out.println(cb.position+"\t"+cb.type);
				}
				
				System.out.println("*****");
				
				out.write("\n");
				out.flush();

				*/

				
			}
			
			
			out.write("<?xml version=\"1.0\" ?><text current=\"1\">");
			out.flush();
			
			for (int i = 0; i<sents_sen.size(); i++){
				
//				ArrayList<VerbForm> verbs1 = vff.findForms(sent);				
//				ArrayList<ClauseVerb> verbs = cvv.reviseVerbs(sent, verbs1);	

				out.write(sents_sen.get(i).getXML());
				out.flush();
			}
			
//			System.in.read();

			
			out.write("</text>");
			out.flush();


			
		} catch(Exception e){
			e.printStackTrace();
			System.exit(0);
		}
		
	}
	
	public void processFileXMLVerbForms(File f,  Writer out, 
			String ext, HashMap<String,ArrayList<String>> frames){
		
		try{
			
int ctr = 1000;
			ArrayList<Sentence> sents = getSentences(f);

			
			out.write("<?xml version=\"1.0\" ?>\n"
					+ "<text current=\"1\">\n"
					+ "<word w=\"====\" l=\"====\" cl=\"001\" cl_al=\"001\" />");
			out.flush();
			
			for (int i = 0; i<sents.size(); i++){
				
				Sentence sent = sents.get(i);
				
				ArrayList<VerbForm> verbs1;
				ArrayList<ClauseVerb> verbs;
				
				if (ext.equals("txt")){
					verbs1 = vff.findForms(sent);
					verbs = cvv.reviseVerbs(sent, verbs1);	
					
				}else{
					verbs1 = vffen.findForms(sent);
					verbs = cvven.reviseVerbs(sent, verbs1);	
				}
				
				System.out.println(sent.getPlainText());
				
				int added = 0;
				
				for (Word w : sent){
					if (!w.clauseConnectedID.equals("")){
						w.cclauseConnectedID = w.clauseConnectedID;
						w.clauseConnectedID = "";
					}
				}
				
				for (VerbForm cv : verbs1) {
					
					
					boolean isreal = false;
					for (String ten:cv.tense) if (!ten.startsWith("N")) isreal = true;
					if (!isreal) continue;
					ctr++;
					int cctr = 0;
					String currentclause = "";
					int currentpos = -1;
					
					for (TextPosition pp : cv) {
						System.out.println(pp.sentpos);

						sent.get(pp.sentpos+added).MWE_part = ctr + (cv.size()>1?":"+cctr:"");
						sent.get(pp.sentpos+added).clauseRelation = "VP";
						sent.get(pp.sentpos+added).clauseConnectedID = "001";
						
						currentclause = sent.get(pp.sentpos+added).clauseID;
						currentpos = pp.sentpos+added;
						cctr++;
					}
					
					String verb = cv.mainword.lemma;
					String res = "";
					if(frames.containsKey(verb)){
						for (String s : frames.get(verb)){
							if (res.length()>0) res += "#";
							res += s;
						}
					}

					if (ext.equals("al")){
						Word frameword = new Word();
						frameword.wordform = "##"+res+"##";
						frameword.lemma = "##FRAME##";
						frameword.pos = "##FRAME##";
						frameword.clauseID = currentclause;
						
						sent.add(currentpos+1, frameword);
						
						added ++;
					}
				}
				
//				System.in.read();
	
				out.write(sents.get(i).getXML());
				out.flush();
			}
			
//			System.in.read();

			
			out.write("</text>");
			out.flush();


			
		} catch(Exception e){
			e.printStackTrace();
			System.exit(0);
		}
		
	}


	public ArrayList<Sentence> getSentences(File f){
		
		ArrayList<Sentence> sents = new ArrayList<Sentence>();
		try{
		DocumentBuilderFactory dbFactory = DocumentBuilderFactory.newInstance();
		DocumentBuilder dBuilder = dbFactory.newDocumentBuilder();
		Document doc = dBuilder.parse(f);
		 
		//optional, but recommended
		//read this - http://stackoverflow.com/questions/13786607/normalization-in-dom-parsing-with-java-how-does-it-work
		doc.getDocumentElement().normalize();
		
		System.out.println("File: "+f.getAbsolutePath());

		Sentence sent = new Sentence();

		NodeList wordList = doc.getElementsByTagName("word");
		Word keep = new Word();

		for (int i = 0; i < wordList.getLength(); i++) {
				 
			Node wordNode = wordList.item(i);
				
			if (wordNode.getNodeType() != Node.ELEMENT_NODE) continue;
				
			Element wordElement = (Element) wordNode;
			
//			System.out.println("WORD: "+wordElement.getAttribute("w")
//						+" "+wordElement.getAttribute("pos"));

			Word t = new Word();
			t.wordform = wordElement.getAttribute("w");
				
				
			t.pos = wordElement.getAttribute("pos");

			t.lemma = wordElement.getAttribute("l");
			
			t.clauseID = wordElement.getAttribute("cl");
			if (wordElement.hasAttribute("cl_old")){
				t.remainingAttr.put("cl",
						wordElement.getAttribute("cl_old"));
			}

				
			if (wordElement.hasAttribute("p")){
				t.CMWE_part = wordElement.getAttribute("p");
			}
			if (wordElement.hasAttribute("cp")){
				t.CMWE_part = wordElement.getAttribute("cp");
			}
			if (wordElement.hasAttribute("m")){
				t.cclauseRelation = wordElement.getAttribute("m");
			}
			if (wordElement.hasAttribute("cm")){
				t.cclauseRelation = wordElement.getAttribute("cm");
			}
			if (wordElement.hasAttribute("cl2")){
				t.clauseConnectedID =
						wordElement.getAttribute("cl2");
			}
			if (wordElement.hasAttribute("cl_al")){
				t.clauseAlign =
						wordElement.getAttribute("cl_al");
			}

							
			if (wordElement.hasAttribute("e") && 
				wordElement.getAttribute("e").equals("True")){
				t.senEnd = true;
				
				if (wordElement.hasAttribute("sen")){
					t.sen = wordElement.getAttribute("sen");
					sent.ID = t.sen;
					
				}
				

			}
			
		
			if (!keep.wordform.equals("")){
				
				if (t.clauseConnectedID.equals("")) 
					t.clauseConnectedID = keep.clauseConnectedID;
				if (t.cclauseConnectedID.equals("")) 
					t.cclauseConnectedID = keep.cclauseConnectedID;
				
				if (t.clauseAlign.equals("")) 
					t.clauseAlign = keep.clauseAlign;
				
				if (t.clauseRelation.equals("")) 
					t.clauseRelation = keep.clauseRelation;
				if (t.cclauseRelation.equals("")) 
					t.cclauseRelation = keep.cclauseRelation;

				keep = new Word();
			}
			
			if (t.wordform.equals("====")) {
				
				
				if (wordElement.hasAttribute("cl_al")
						|| wordElement.hasAttribute("cl2")
						|| wordElement.hasAttribute("m")
						){
					
					if (sent.size()==0){
						keep = t;
					} else {

						String ww = sent.get(sent.size()-1).wordform;
						t.wordform = ww.substring(ww.length()-1);
						t.lemma = t.wordform;
					}
				} else continue;
			}
			

			
			sent.add(t);
				
			if (t.senEnd) {
				sents.add(sent);
				sent = new Sentence();
			}
			

		}
		} catch(Exception e){
			e.printStackTrace();
		}
	
		return sents;
	}
	
	public ArrayList<Sentence> getSentencesWithS(File f){
		
		ArrayList<Sentence> sents = new ArrayList<Sentence>();
		
		try{
		DocumentBuilderFactory dbFactory = DocumentBuilderFactory.newInstance();
			DocumentBuilder dBuilder = dbFactory.newDocumentBuilder();
			Document doc = dBuilder.parse(f);
			 
			//optional, but recommended
			//read this - http://stackoverflow.com/questions/13786607/normalization-in-dom-parsing-with-java-how-does-it-work
			doc.getDocumentElement().normalize();
			
 
			Sentence sent = new Sentence();
			
			
			NodeList sentList = doc.getElementsByTagName("S");

			
			for (int j = 0; j < sentList.getLength(); j++) {
				
				Node sentNode = sentList.item(j);
				
				if (sentNode.getNodeType() != Node.ELEMENT_NODE) continue;
				
				Element sentElement = (Element) sentNode;
				
				NodeList wordList = sentElement.getElementsByTagName("word");
				
				sent = new Sentence();
								
				for (int i = 0; i < wordList.getLength(); i++) {
					 
					Node wordNode = wordList.item(i);
					
					if (wordNode.getNodeType() != Node.ELEMENT_NODE) continue;
						
					Element wordElement = (Element) wordNode;
					
//					System.out.println("WORD: "+wordElement.getAttribute("w")
//								+" "+wordElement.getAttribute("pos"));

					Word t = new Word();
					t.wordform = wordElement.getAttribute("w");
												
					t.pos = wordElement.getAttribute("pos");
					t.lemma = wordElement.getAttribute("l");
					
					t.clauseID = wordElement.getAttribute("cl");
						
						
					if (wordElement.hasAttribute("p")){
						t.CMWE_part = wordElement.getAttribute("p");
					}
					if (wordElement.hasAttribute("cp")){
						t.CMWE_part = wordElement.getAttribute("cp");
					}
					if (wordElement.hasAttribute("m")){
						t.cclauseRelation = wordElement.getAttribute("m");
					}
					if (wordElement.hasAttribute("cm")){
						t.cclauseRelation = wordElement.getAttribute("cm");
					}
					if (wordElement.hasAttribute("cl2")){
						t.clauseConnectedID =
								wordElement.getAttribute("cl2");
					}
					if (wordElement.hasAttribute("cl_al")){
						t.clauseAlign = wordElement.getAttribute("cl_al");
					}
					if (wordElement.hasAttribute("cl_old")){
						t.clauseID = wordElement.getAttribute("cl_old");
					}
									
					if (wordElement.hasAttribute("e") && 
						wordElement.getAttribute("e").equals("True")){
						
						t.senEnd = true;
						if (wordElement.hasAttribute("sen")){
							t.sen = wordElement.getAttribute("sen");
							sent.ID = t.sen;
							
						}
					}

							
//					if (t.pos.equals("")) t.pos="M";
						
					sent.add(t);
						
				}

				sents.add(sent);
				
			}

			
		} catch(Exception e){
			e.printStackTrace();
			System.exit(0);
		}
		
		return sents;
	}






}
