package bg.bas.dcl.multilingual.ClauseSplitting.rules;

import java.util.ArrayList;
import java.util.HashMap;

import bg.bas.dcl.entities.Conjunction;
import bg.bas.dcl.entities.Sentence;
import bg.bas.dcl.entities.VerbForm;
import bg.bas.dcl.multilingual.Chunker.VerbFormRecogniser.ClauseVerb;
import bg.bas.dcl.multilingual.ClauseSplitting.ClauseBorder;
import bg.bas.dcl.multilingual.ClauseSplitting.ClauseSplittingComplexObject;
import bg.bas.dcl.multilingual.ClauseSplitting.ClauseStack;

public class OptionalConjunctionsAfterClauseSplittingRule implements
		ClauseSplittingRule {
	
	public boolean isEndingRule = true;
	
	ArrayList<Conjunction> conjList = new ArrayList<Conjunction>();
	
	public OptionalConjunctionsAfterClauseSplittingRule (ArrayList<Conjunction> conjList) {
		this.conjList = conjList;
		System.out.println(conjList.size());

	}

	
	public ClauseSplittingComplexObject findClauseBorders(
			Sentence sentence,
			ArrayList<ClauseVerb> verbs, 
			int spos, int epos,
			ClauseStack stack
			){
		
		ClauseSplittingComplexObject obj = new ClauseSplittingComplexObject();
		obj.cls = stack;
		obj.clborders = new ArrayList<ClauseBorder>();
				
		if (obj.cls.getTypeFromStack(1).equals("SCOC")){
			spos = Math.max(obj.cls.getIndexFromStack(1),spos);
		}
		
		if (obj.cls.stackSize()>0 && spos < obj.cls.getIndexFromStack(1)) {
			spos = obj.cls.getIndexFromStack(1);
		}
		
//		for (int i=spos; i<epos+1; i++) {
		for (int i=epos;i>spos-1; i--) {
			
					
cl:			for (Conjunction c : conjList){
	
				
				if (c.isCompulsaryCO) continue;
				if (!c.type.startsWith("Opt")) continue;
				
				
				String[] parts = c.lemma.split(" ");
				
				for (int k=0; k<parts.length; k++) {
					if (i+k<sentence.size() && 
							!parts[k].equalsIgnoreCase(sentence.get(i+k).lemma)){
						continue cl;
					}

				}
				

				int pos = i;
				int nextpos = pos + parts.length - 1;
				
				
				if (c.preceedingCommaCO) {
					for (int p = i-1; p > Math.max(spos, i-5); p--) {
						if (sentence.get(p).wordform.equals(",")) {
							
							pos = p+1;
							
						}
					}
				}
				
				if (verbIsPresent(sentence, verbs, 
						obj.cls
							.getIndexFromStack(1),i)){
					
					if (obj.cls.getTypeFromStack(1).endsWith("COC") && c.type.startsWith("C"))	{
						
						obj.clborders.add(new ClauseBorder(pos-1, "CC"));
						obj.cls.removeFromStack();
						
						obj.clborders.add(new ClauseBorder(pos, "COC"));
						obj.cls.putInStack("COC", pos);
						
					}
					
					if (obj.cls.getTypeFromStack(1).endsWith("COS") && c.type.startsWith("C"))	{
						obj.clborders.add(new ClauseBorder(pos-1, "CC"));
						obj.cls.removeFromStack();
						
						obj.clborders.add(new ClauseBorder(pos, "COS"));
						obj.cls.putInStack("COS", pos);
					}
	
					if (c.type.startsWith("S"))	{
						obj.clborders.add(new ClauseBorder(pos-1, "CC"));
						obj.cls.removeFromStack();
						
						obj.clborders.add(new ClauseBorder(pos, "COS"));
						obj.cls.putInStack("COS", pos);
					}
				}
				
				i = nextpos;
				break;

			}
		}
		
		return obj;

	}
	public boolean isEnding(){
		return isEndingRule;
	}

	public boolean verbIsPresent(Sentence sent, 
			ArrayList<ClauseVerb> verbs, int begin, int end){
		
		
		
		int vind = -1;
		for (VerbForm vf : verbs) {
			if (begin <= vf.get(0).sentpos && vf.get(vf.size()-1).sentpos <= end
					&& sent.get(vf.get(0).sentpos).clauseID.equals(sent.get(begin).clauseID)) {
		
				System.out.println("VC: begin "+begin + " end "+end);
				System.out.println("VC: "+sent.get(vf.get(0).sentpos).wordform 
						+ " "+sent.get(vf.get(0).sentpos).clauseID);
				System.out.println("VC: "+sent.get(begin).wordform + " "+sent.get(begin).clauseID);
				vind = vf.get(vf.size()-1).sentpos;
				break;
			}
		}
		
		if (vind > -1 && vind < end) return true;
		
		return false;
	}

}
