package bg.bas.dcl.semantic.processing;

import java.util.ArrayList;

import bg.bas.dcl.entities.Word;
import bg.bas.dcl.multilingual.Chunker.VerbFormRecogniser.VerbComponent;

public class NounPhraseComponent {

	public String form = "";
	public String lemma = "";
	public String pos = "";
	public String gram = "";
	
	public boolean isPhraseModel = false;
	
	public boolean  isHead = false;
	
	public boolean optional = false;
	public boolean isNegative = false;
	public int optionalMin = 0;
	public int optionalMax = 0;
	public ArrayList<NounPhraseComponent> optionalVariants = 
			new ArrayList<NounPhraseComponent>();

	public void readComponentFromString(String comp, int n){
		
		if (comp.trim().startsWith("$")) {
			form = comp.substring(1);
			isPhraseModel = true;
			return;
		}

		if (comp.startsWith("(") && comp.endsWith(")")) {
		
			comp = comp.substring(1, comp.length()-1);

			String options1 = comp.substring(0,comp.indexOf(",")).trim();
			
			comp = comp.substring(comp.indexOf(",")+1);
					
			String options2 = comp.substring(0,comp.indexOf(",")).trim();
			
//			System.out.println(options1+"\t"+options2);

			String options3 = comp.substring(comp.indexOf(",")+1);

			optional = true;
			
			optionalMin = Integer.valueOf(options1);
			optionalMax = Integer.valueOf(options2);
			
//			System.out.println("OPTIONS "+optionalNum+" "+options2);
			
			if (options3.startsWith("{") && options3.endsWith("}")){
				String[] variants = options3.substring(1,options3.length()-1)
						.split(",");
				
				for (String v : variants){
					NounPhraseComponent npc = new NounPhraseComponent();
					npc.readSingleComponentFromString(v.trim());
					
//					System.out.println("OPTIONAL "+
//							v + "\t" + vc.lemma + "\t" + vc.pos);
					optionalVariants.add(npc);
					
					
							
				}
				
			}
			
		} else readSingleComponentFromString(comp);

		
	}

	
	public void readSingleComponentFromString(String comp){
		
		comp = comp.trim();
		
		if (comp.startsWith("-")) {
			isNegative =true;
			comp = comp.substring(1);
		}
		
		if (comp.contains(":")) {
			lemma = comp.substring(0,comp.indexOf(":"));
			comp = comp.substring(comp.indexOf(":")+1);
		} else {
			if (comp.length()>0 && comp.charAt(0) != '-' 
					&& (comp.charAt(0)<'A' || comp.charAt(0)>'Z')) {
				lemma = comp;
				comp = "";
			}
		}	
		
		while (comp.length()>0 
				&& (comp.charAt(0) == '-' 
				|| (comp.charAt(0)>='A' && comp.charAt(0)<='Z'))){
			pos += comp.charAt(0);
			comp = comp.substring(1);
		}
		if (pos.equals("COMMA")) {
			pos = "U";
			lemma = ",";
			form = ",";
		}
		gram = comp;
		
	}

	public boolean isMatch(Word t){
		
		
		boolean res = true;
		
		
		if (!lemma.equals("") && !lemma.equals(t.lemma)) return false;
		
		// ONLY OPTIONAL CAN BE NEGATIVE
		if (!optional) {

			if (!t.pos.startsWith(pos)) return false;
			
			for (int i = 0; i<gram.length(); i++){
				String g = gram.substring(i, i+1);
				
				if (!t.pos.contains(g)) return false;
			}
			
		} else {

			boolean variant;
			
			if (optionalVariants.get(0).pos.startsWith("-")){
				variant = true;
				for (NounPhraseComponent nc : optionalVariants) {
//					System.out.println("-MATCH " + t.pos + "\t" + vc.pos.substring(1));
					
					if (t.pos.startsWith(nc.pos.substring(1))) {
						variant = false;
					}
				}
			} else {
				variant = false;
				for (NounPhraseComponent vc : optionalVariants) {
					
					variant = variant || vc.isMatch(t);

//					System.out.println("+MATCH " + t.pos + "\t" + vc.pos
//							+ "\t" + variant);
				}
			}
			
//			System.out.println("MATCH " + t.pos + "\t" + optionalVariants.get(0).pos + "\t"+variant);
			return variant;
			
		}
	
		return res;
		
	}

}
