package bg.bas.dcl.semantic.processing;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import bg.bas.dcl.entities.Sentence;
import bg.bas.dcl.entities.VerbForm;
import bg.bas.dcl.semantic.lexical_db.MITJavaWordNetAccess;

public class VerbArgumentModel extends 
				ArrayList<VerbArgumentStructure>{
	
	public String synsetID = "";
	public Sentence sent ;
	MITJavaWordNetAccess mitwn ;

	HashMap<String,Integer> direct = new HashMap<String,Integer>();
	HashMap<String,Integer> indirect = new HashMap<String,Integer>();
	
	public VerbArgumentModel(String synID, Sentence s, MITJavaWordNetAccess m){
		synsetID = synID;
		sent = s;
		mitwn = m;
	}
	
	public void summerise(){
		
		direct = new HashMap<String,Integer>();
		indirect = new HashMap<String,Integer>();
		
		for (VerbArgumentStructure vas : this) {
			
			ArrayList<String> usedpreps = new ArrayList<String>();
			
			for (VerbArgument va : vas) {
				String prep = va.preposition;
				
				String label = "";
				
				if (va.nounphrase
						.headPosition.sentpos>-1
						&& va.nounphrase
						.headPosition.sentpos<sent.size()){
					label = mitwn.getLexicalName(
						sent.get(va.nounphrase
								.headPosition.sentpos).wn);
				}
				
				if (label == null) label="";
				
				System.err.println("LABEL: " + label);
				
				if (prep.equals("")){
					
					if (!label.equals("")){ 

						if (direct.containsKey(label)) {
							direct.put(label, direct.get(label)+1);
						}else{
							direct.put(label, 1);
						}
					}
				}else{
				
					if (!label.equals("")){ 
						if (indirect.containsKey(label)) {
							indirect.put(label, 
									indirect.get(label)+1);
						}else{
							indirect.put(label, 1);
						}
					}
					
					if (!usedpreps.contains(prep)){
						if (indirect.containsKey(prep)) {
							indirect.put(prep, 
									indirect.get(prep)+1);
							
						}else{
							indirect.put(prep, 1);
						}

						if (!label.equals("")){ 
							if (indirect.containsKey(prep+" "+label)) {
								
								indirect.put(prep+" "+label, 
										indirect.get(prep)+1);
							}else{
								
								indirect.put(prep+" "+label, 1);
							}
						}
					}
					
					usedpreps.add(prep);

				}
			
			}
			
		}
		
	}
	
	public String getSummary(){
		
		String result = "EXAMPLES: " + this.size()+"<br>\n";
		
		
		result+="DIRECT<br>\n";
		
		for (String key : direct.keySet()) {
			
			result += key + "\t" + direct.get(key) +"<br>\n";
			
		}
			
			
		result+="<br>INDIRECT<br>\n";
		
		for (String key : indirect.keySet()) {
			
			if (!key.contains(" ") && !key.contains("noun")) 
				result += key + "\t" + indirect.get(key)+"<br>\n";
			
		}
		
		for (String key : indirect.keySet()) {
			
			if (!key.contains(" ") && key.contains("noun")) 
				result += key + "\t" + indirect.get(key)+"<br>\n";
			
		}

		
		for (String key : indirect.keySet()) {
			
			if (key.contains(" ")) 
				result += key + "\t" + indirect.get(key)+"<br>\n";
			
		}

			


		return result;
	}

}
