package bg.bas.dcl.xmlcorpusprocessor;

import java.io.File;
import java.io.FileOutputStream;
import java.io.OutputStreamWriter;
import java.io.Writer;
import java.util.ArrayList;
import java.util.HashMap;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import bg.bas.dcl.entities.Sentence;
import bg.bas.dcl.entities.Word;

public class XMLCorpusProcessor {

	
	void writeSentsToFile(ArrayList<Sentence> sents, String fout){
		try{
			Writer out = new OutputStreamWriter(
							new FileOutputStream(fout)); 
			
			out.write("<?xml version=\"1.0\" ?>\n<text current=\"0\">\n");
			
			for (Sentence sent : sents) {
				for (Word w : sent){
					out.write(w.toXML()+"\n");
					out.flush();
				}
			}
			
			out.write("</text>");

			
			out.flush();
			out.close();
	
			
		} catch(Exception e){
			e.printStackTrace();
		}	

	}
	
	
	public ArrayList<Sentence> getSentencesFromFile(File f){
		
		ArrayList<Sentence> sents = new ArrayList<Sentence>();

		try{


			DocumentBuilderFactory dbFactory = 
					DocumentBuilderFactory.newInstance();
			DocumentBuilder dBuilder = dbFactory.newDocumentBuilder();
			Document doc = dBuilder.parse(f);

			doc.getDocumentElement().normalize();
				 
			
			NodeList wordList = doc.getElementsByTagName("word");
			

			Sentence sent = new Sentence();
						
			for (int j = 0; j < wordList.getLength(); j++) {
				
				Node wordNode = wordList.item(j);
				
				if (wordNode.getNodeType() != Node.ELEMENT_NODE) continue;
				
				Element wordElement = (Element) wordNode;
				
				Word w = new Word();
				w.wordform = wordElement.getAttribute("w");
				w.lemma = wordElement.getAttribute("l");
				w.wn = wordElement.getAttribute("wn");
				w.pos = wordElement.getAttribute("pos");
				
				if (wordElement.hasAttribute("u")) 
					w.remainingAttr.put("u", wordElement.getAttribute("u"));
				if (wordElement.hasAttribute("s")) 
					w.remainingAttr.put("s", wordElement.getAttribute("s"));
				if (wordElement.hasAttribute("t")) 
					w.remainingAttr.put("t", wordElement.getAttribute("t"));

				if (wordElement.hasAttribute("p")) {
					w.remainingAttr.put("p", wordElement.getAttribute("p"));
					
					
				}
				
				if (wordElement.hasAttribute("mwe")) {
					w.MWE = wordElement.getAttribute("mwe");
				
				}

				if (!w.wordform.equalsIgnoreCase("CLIPPING")) sent.add(w);

				if (wordElement.hasAttribute("e")
						&& wordElement.getAttribute("e")
						.equalsIgnoreCase("true")) {
					w.remainingAttr.put("e", "True");
					
					sents.add(sent);
					sent = new Sentence();

				}

				
			}

					
		}catch(Exception e){
			e.printStackTrace();
		}
		
		return sents;
		
	}


}
